/*****************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of
conditions, the following disclaimer and the list of authors.  Redistributions in binary
form must reproduce the above copyright notice, this list of conditions, the following
disclaimer and the list of authors in the documentation and/or other materials provided
with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Log$
 Revision 1.3  2004/05/19 04:07:43  reddawg
 kmalloc(size,pid) no more it is no kmalloc(size); the way it should of been

 Revision 1.2  2004/04/28 02:22:55  reddawg
 This is a fiarly large commit but we are starting to use new driver model
 all around

 Revision 1.1.1.1  2004/04/15 12:07:07  reddawg
 UbixOS v1.0

 Revision 1.6  2004/04/13 16:36:34  reddawg
 Changed our copyright, it is all now under a BSD-Style license



 $Id$

*****************************************************************************************/

#include <ubixfs/ubixfs.h>
#include <vfs/file.h>
#include <vfs/mount.h>
#include <ubixos/types.h>
#include <lib/kmalloc.h>
#include <lib/kprintf.h>
#include <string.h>

int addDirEntry(struct directoryEntry *dir,fileDescriptor *fd) {
  int i = 0x0;
  uInt32 entries = 0x0;
  struct directoryEntry *tmp = 0x0;

  tmp = (struct directoryEntry *)kmalloc(fd->size);

  readUbixFS(fd,(char *)tmp,fd->offset,fd->size);
  entries = fd->size/sizeof(struct directoryEntry);
  for (i=0;(tmp[i].attributes != 0x0) && (i < entries);i++);

  if (i == entries) {
    tmp = (struct directoryEntry *)kmalloc(0x1000);
    i = 0x0;
    }
  else {
    fd->offset = 0x0;
    }
  kmemcpy(&tmp[i],dir,sizeof(struct directoryEntry));
  
  if (writeUbixFS(fd,(char *)tmp,fd->offset,fd->size) == 0x0) {
    kprintf("Error Creating Directory\n");
    }
  
  return(0x0);
  }

int mkDirUbixFS(char *directory,fileDescriptor *fd) {
  int block = 0x0;

  struct directoryEntry *dir   = 0x0;
  struct directoryEntry *entry = 0x0;
  struct ubixFsInfo *fsInfo    = fd->mp->fsInfo;
  
  block = getFreeBlocks(1,fd);
  if (block != 0x0) {
    dir   = (struct directoryEntry *)kmalloc(blockByteSize);
    entry = (struct directoryEntry *)kmalloc(sizeof(struct directoryEntry));

    entry->startCluster = block;
    entry->size         = blockByteSize;
    entry->attributes   = 0x8000;
    entry->permissions  = 0xEAA;
    sprintf(entry->fileName,directory);
    
    fd->mp->device->devInfo->write(fd->mp->device->devInfo->info,dir,fd->mp->diskLabel->partitions[fd->mp->partition].pOffset+fsInfo->blockAllocationTable[block].realSector,blockSize);
    addDirEntry(entry,fd);
    kfree(dir);
    kfree(entry);
    }

  return(0x0);
  }

/***
 END
 ***/
